<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="4" class="text-align-left">
                            <h3>Documents</h3>
                        </el-col>
                        <el-col :span="20">
                            <el-row :gutter="20">
                                <el-col :lg="8" :md="8" :sm="24">
                                    <el-input 
                                        prop="keyword" 
                                        v-model="filter.keyword" 
                                        ref="keyword" 
                                        name="keyword" 
                                        placeholder="Tracking number, document number, title" 
                                        size="large" 
                                        class="filter-item width-100" 
                                        clearable 
                                        @keyup.enter.native="getDocuments(1, false)" 
                                        @clear="getDocuments(1, false)"/>
                                </el-col>   
                                <el-col :lg="6" :md="6" :sm="24">
                                    <el-select
                                        ref="author"
                                        name="author"
                                        class="width-100"
                                        clearable
                                        filterable
                                        remote
                                        :remote-method="getAuthors"
                                        v-model="filter.author"
                                        value-key="id"
                                        placeholder="Full name"
                                        no-data-text="No Record Found"
                                        :loading="authorLoading"
                                        @clear="handleClearAuthor()">
                                        <el-option
                                            v-for="item in authors"
                                            :key="item.id"
                                            :label="item.fullname.capitalize()"
                                            :value="item.id">     
                                            <span style="float: left">{{ item.fullname.capitalize() }}</span>
                                            <strong style="float: right; color: #8492a6; font-size: 13px">{{ item.code }}</strong>                   
                                        </el-option>
                                    </el-select>
                                </el-col>                             
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getDocuments(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <router-link
                                        to="/documents/add"
                                        v-slot="{ href, route, navigate, isActive, isExactActive }">
                                        <a :href="href" @click="navigate" class="el-button filter-item width-100 el-button--success el-button--medium">
                                            <span><i class="ion-ios-add-circle"></i> Add</span>
                                        </a>
                                    </router-link>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>
                </div>
                <el-table v-loading="tableLoading" :data="documents" style="width: 100%" :height="tableHeight()" fit highlight-current-row v-infinite-scroll="loadMore">
                    <el-table-column
                        fixed="left"
                        label="Tracking No"
                        width="175">
                        <template slot-scope="scope">
                            <span style="color:#3E89FA;">{{ scope.row.tracking_number }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Document No"
                        width="175">
                        <template slot-scope="scope">
                            <span>{{ scope.row.document_number }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Title"
                        width="250">
                        <template slot-scope="scope">
                            <span>{{ convertAmpersand(scope.row.title).capitalize() }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Status"
                        width="250">
                        <template slot-scope="scope">
                            <span>{{ convertAmpersand(scope.row.statuses[0].status.name).capitalize() }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Author"
                        width="150">
                        <template slot-scope="scope">
                            <span>{{ scope.row.author.fullname.capitalize() }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Last Updated"
                        width="150">
                        <template slot-scope="scope">
                            {{ dateFormat(scope.row.updated) }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        fixed="right"
                        label="Action"
                        min-width="200">
                        <template slot-scope="{row}">
                            <router-link
                                :to="`/documents/${row.id}`"
                                v-slot="{ href, route, navigate, isActive, isExactActive }">
                                <a v-permission="[row, 'document', 'viewown']" :href="href" @click="navigate" class="el-link el-link--primary">Edit</a>
                            </router-link>
                            <el-button v-permission="[row, 'document', 'deleteown']" type="text" class="text-danger" @click="handleArchive(row)" style="margin-left: 10px;vertical-align:middle;">Archive</el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, tableHeight, convertAmpersand } from '../../utils/index';
export default {
    name: 'Documents',
    directives: {
        permission
    },
    data(){
        return{
            tableLoading: false,
            authorLoading: false,
            filter: {
                keyword: '',
                author: null
            },            
        }
    },
    computed:{
        ...mapGetters('auth', ['user']),
        ...mapGetters('user', ['authors']),
        ...mapGetters('document', [
            'documents',
            'pagination'
        ])
    },
    created(){
        const self = this;

        self.getDocuments(1, false);

        if(self.user.role.slug != 'root'){
            self.documentForm.organization = self.user.organization.id; 
        }
    },
    methods: {
        dateFormat,
        tableHeight,
        convertAmpersand,
        getAuthors(q){
            const self = this;

            if(q.length >= 3){
                self.authorLoading = true;
                self.$store.dispatch('user/getAuthors', {
                    q: q,
                    page: 1,
                    perpage: 25,
                    exclude: 'role'
                }).then(() => {
                    self.authorLoading = false;
                });
            }
        },
        getDocuments(page, loadmore){
            const self = this;

            self.tableLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore,
                archived: false
            };

            if(self.filter.keyword.trim().length > 0){
                params.q = self.filter.keyword;
            }

            if(self.filter.author != null){
                params.author = self.filter.author;
            }

            self.$store.dispatch('document/getDocuments', params).then(()=>{
                self.tableLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getDocuments(self.pagination.page + 1, true);
            }
        },
        handleAddNew(){
            const self = this;
            self.pageStatus = 'add';
            location.href = '/documents/add';
        },
        handleEdit(document){
            const self = this;
            location.href = '/documents/' + document.id;
        },
        handleArchive(document){
            const self = this;

            self.$confirm('You are about to save this document to the archive. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.tableLoading = true;
                self.$store.dispatch('document/deleteDocument', {
                    id: document.id
                }).then((response) => {
                    self.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });
                    }
                });
            });
        },

        handleClearAuthor(){
            const self = this;
            self.filter.author = null;
            self.$store.dispatch('user/resetAuthors');
        },
        
    }
}
</script>